export interface Charset<Name extends string = string> {
	name: Name;
	encode: (str: string) => Buffer;
	decode: (buf: Buffer) => string;
}

export const FALLBACK_CHARSET = {
	encode: (str: string) => Buffer.from(str, 'utf-8'),
	decode: (buf: Buffer) => buf.toString('utf-8'),
	name: 'utf-8' as const,
} satisfies Charset;
