import * as v from 'valibot';

export const DELTA_PATH_SEPARATOR = '/' as const;

export const tokenizePath = (path: string) => {
	return path.split(DELTA_PATH_SEPARATOR);
};

export const combinePathFragments = (pathFragments: string[]) => {
	return pathFragments.join(DELTA_PATH_SEPARATOR);
};

export const getObjectSchema = (schema?: v.ObjectSchema<any>, path?: string): v.BaseSchema => {
	if (typeof path !== 'string') {
		return schema as v.BaseSchema;
	}
	if (path.length <= 0) {
		return schema as v.BaseSchema;
	}
	const pathFragments = tokenizePath(path);
	const thisPath = pathFragments.shift() as string;
	return getObjectSchema(schema?.entries?.[thisPath], combinePathFragments(pathFragments));
};
